-- Character Info for F-ZERO: Kart

--Yoinked from Hostmod; you can thank me later.
local colLookup = {	[SKINCOLOR_WHITE] = "\x80",	[SKINCOLOR_SILVER] = "\x80",	[SKINCOLOR_SLATE] = "\x80",		[SKINCOLOR_ULTRAVIOLET] = "\x81",	[SKINCOLOR_PURPLE] = "\x81",	[SKINCOLOR_FUCHSIA] = "\x81",		[SKINCOLOR_POPCORN] = "\x82",	[SKINCOLOR_QUARRY] = "\x82",	[SKINCOLOR_YELLOW] = "\x82",	[SKINCOLOR_MUSTARD] = "\x82",	[SKINCOLOR_CROCODILE] = "\x82",	[SKINCOLOR_OLIVE] = "\x82",		[SKINCOLOR_LIME] = "\x83",	[SKINCOLOR_HANDHELD] = "\x83",	[SKINCOLOR_MOSS] = "\x83",	[SKINCOLOR_CAMOUFLAGE] = "\x83",	[SKINCOLOR_ROBOHOOD] = "\x83",	[SKINCOLOR_MINT] = "\x83",	[SKINCOLOR_GREEN] = "\x83",	[SKINCOLOR_PINETREE] = "\x83",	[SKINCOLOR_ALGAE] = "\x83",	[SKINCOLOR_PLAGUE] = "\x83",	[SKINCOLOR_EMERALD] = "\x83",	[SKINCOLOR_SWAMP] = "\x83",	[SKINCOLOR_DREAM] = "\x83",		[SKINCOLOR_PERIWINKLE] = "\x84",	[SKINCOLOR_BLUE] = "\x84",	[SKINCOLOR_BLUEBERRY] = "\x84",	[SKINCOLOR_NOVA] = "\x84",		[SKINCOLOR_CINNAMON] = "\x85",	[SKINCOLOR_RUBY] = "\x85",	[SKINCOLOR_RASPBERRY] = "\x85",	[SKINCOLOR_CHERRY] = "\x85",	[SKINCOLOR_RED] = "\x85",	[SKINCOLOR_CRIMSON] = "\x85",	[SKINCOLOR_MAROON] = "\x85",	[SKINCOLOR_FLAME] = "\x85",	[SKINCOLOR_SCARLET] = "\x85",	[SKINCOLOR_KETCHUP] = "\x85",		[SKINCOLOR_GREY] = "\x86",	[SKINCOLOR_NICKEL] = "\x86",	[SKINCOLOR_BLACK] = "\x86",	[SKINCOLOR_SKUNK] = "\x86",	[SKINCOLOR_JET] = "\x86",		[SKINCOLOR_DAWN] = "\x87",	[SKINCOLOR_SUNSET] = "\x87",	[SKINCOLOR_CREAMSICLE] = "\x87",	[SKINCOLOR_ORANGE] = "\x87",	[SKINCOLOR_PUMPKIN] = "\x87",	[SKINCOLOR_ROSEWOOD] = "\x87",	[SKINCOLOR_BURGUNDY] = "\x87",	[SKINCOLOR_TANGERINE] = "\x87",		[SKINCOLOR_CARIBBEAN] = "\x88",	[SKINCOLOR_AZURE] = "\x88",	[SKINCOLOR_AQUA] = "\x88",	[SKINCOLOR_TEAL] = "\x88",	[SKINCOLOR_CYAN] = "\x88",	[SKINCOLOR_JAWZ] = "\x88",	[SKINCOLOR_CERULEAN] = "\x88",	[SKINCOLOR_NAVY] = "\x88",	[SKINCOLOR_SAPPHIRE] = "\x88",		[SKINCOLOR_PASTEL] = "\x89",	[SKINCOLOR_MOONSLAM] = "\x89",	[SKINCOLOR_DUSK] = "\x89",	[SKINCOLOR_TOXIC] = "\x89",	[SKINCOLOR_MAUVE] = "\x89",	[SKINCOLOR_LAVENDER] = "\x89",	[SKINCOLOR_BYZANTIUM] = "\x89",	[SKINCOLOR_POMEGRANATE] = "\x89",		[SKINCOLOR_GOLD] = "\x8A",	[SKINCOLOR_ROYAL] = "\x8A",	[SKINCOLOR_BRONZE] = "\x8A",	[SKINCOLOR_COPPER] = "\x8A",	[SKINCOLOR_THUNDER] = "\x8A",		[SKINCOLOR_ARTICHOKE] = "\x8B",	[SKINCOLOR_VOMIT] = "\x8B",	[SKINCOLOR_GARDEN] = "\x8B",	[SKINCOLOR_TEA] = "\x8B",	[SKINCOLOR_PISTACHIO] = "\x8B",		[SKINCOLOR_PIGEON] = "\x8C",	[SKINCOLOR_PLATINUM] = "\x8C",	[SKINCOLOR_STEEL] = "\x8C",		[SKINCOLOR_FAIRY] = "\x8D",	[SKINCOLOR_SALMON] = "\x8D",	[SKINCOLOR_PINK] = "\x8D",	[SKINCOLOR_ROSE] = "\x8D",	[SKINCOLOR_BRICK] = "\x8D",	[SKINCOLOR_LEMONADE] = "\x8D",	[SKINCOLOR_BUBBLEGUM] = "\x8D",	[SKINCOLOR_LILAC] = "\x8D",		[SKINCOLOR_SEPIA] = "\x8E",	[SKINCOLOR_BEIGE] = "\x8E",	[SKINCOLOR_WALNUT] = "\x8E",	[SKINCOLOR_BROWN] = "\x8E",	[SKINCOLOR_LEATHER] = "\x8E",	[SKINCOLOR_RUST] = "\x8E",	[SKINCOLOR_WRISTWATCH] = "\x8E",		[SKINCOLOR_PEACH] = "\x8F",	[SKINCOLOR_CARAMEL] = "\x8F",	[SKINCOLOR_CREAM] = "\x8F"}

local function GetDSR(skin)
	return (26*4 + skins[skin].kartspeed*2 + (9 - skins[skin].kartweight))*8
end

local function GetMaxHealth(skin)
	local base_health = 1000
	local health_adjust = ((skins[skin].kartspeed - 5) + (skins[skin].kartweight - 5))*25
	local total_health = base_health + health_adjust
	
	
	if total_health > 1100 then
		total_health = "\x82"..string.format("%04i", $).."\x80"
	elseif total_health > 1000 then
		total_health = "\x85"..string.format("%04i", $).."\x80"
	elseif total_health > 900 then
		total_health = "\x81"..string.format("%04i", $).."\x80"
	else
		total_health = "\x83"..string.format("%04i", $).."\x80"
	end
	
	return total_health
end

-- Just porting hardcode here
local function GetTopSpeed(skin)
	local ORIG_FRICTION = 62914
	local k_speed = 150
	local g_cc = FRACUNIT
	local xspd = 3072
	local kartspeed = skins[skin].kartspeed
	local finalspeed
	local wt, tspdbonus, scaledbonus, scaledfinalspeed, grip
	
	k_speed = $ + (kartspeed*3)

	if gamespeed == 0 then
		g_cc = 53248 + xspd
	elseif gamespeed == 2 then
		g_cc = 77824 + xspd
	else
		g_cc = 65536 + xspd
	end

	
	finalspeed = FixedMul(FixedMul(k_speed<<14, g_cc), FRACUNIT)
	
	wt = (skins[skin].kartweight - 1)
	local fricmod = 384
	
	if gamespeed == 2 then
		fricmod = 320
	end
	
	grip = min(ORIG_FRICTION + (fricmod*(5 - wt)), FRACUNIT)

	tspdbonus = FixedDiv(FRACUNIT, 8*FRACUNIT)
	scaledbonus = FixedMul(FixedDiv(tspdbonus, 8*FRACUNIT), wt*FRACUNIT)

	scaledfinalspeed = FixedRound(FixedMul(FixedMul(finalspeed, FRACUNIT+scaledbonus), grip))
	local speed_rating
	
	local kds = CV_FindVar("kartdisplayspeed")
	if kds.value == 1 then --KM/H
		speed_rating = string.format("%03i", (FixedMul(scaledfinalspeed, 142371))/FRACUNIT).."KM/H"
	elseif kds.value == 2 then -- MPH
		speed_rating = string.format("%03i", (FixedMul(scaledfinalspeed, 88465))/FRACUNIT).."MPH "
	else -- Fracunits, Percent, or Off
		speed_rating = string.format("%03i", (scaledfinalspeed/FRACUNIT)).."FU/T"
	end
	
	local speed_num = scaledfinalspeed/FRACUNIT
	
	if gamespeed == 0 then
		if speed_num > 39
			speed_rating = "\x82"..$.."\x80"
		elseif speed_num > 37 then
			speed_rating = "\x85"..$.."\x80"
		elseif speed_num > 35 then
			speed_rating = "\x81"..$.."\x80"
		else
			speed_rating = "\x83"..$.."\x80"
		end
	elseif gamespeed == 2 then
		if speed_num > 56
			speed_rating = "\x82"..$.."\x80"
		elseif speed_num > 53 then
			speed_rating = "\x85"..$.."\x80"
		elseif speed_num > 50 then
			speed_rating = "\x81"..$.."\x80"
		else
			speed_rating = "\x83"..$.."\x80"
		end
	else
		if speed_num > 47
			speed_rating = "\x82"..$.."\x80"
		elseif speed_num > 44 then
			speed_rating = "\x85"..$.."\x80"
		elseif speed_num > 41 then
			speed_rating = "\x81"..$.."\x80"
		else
			speed_rating = "\x83"..$.."\x80"
		end
	end
	return speed_rating
end

local function GetAcceleration(skin)
	local accel = 9 - skins[skin].kartspeed
	local rating
	
	if accel > 6
		rating = "\x82".."S".."\x80"
	elseif accel > 4
		rating = "\x85".."A".."\x80"
	elseif accel > 2
		rating = "\x81".."B".."\x80"
	else
		rating = "\x83".."C".."\x80"
	end

	return rating
end

local function GetHandling(skin)
	local wt = 9 - skins[skin].kartweight
	local rating

	if wt > 6
		rating = "\x82".."S".."\x80"
	elseif wt > 4
		rating = "\x85".."A".."\x80"
	elseif wt > 2
		rating = "\x81".."B".."\x80"
	else
		rating = "\x83".."C".."\x80"
	end

	return rating
	
end

local function GetGrip(skin)
	local wt = 9 - skins[skin].kartweight
	local rating

	if wt > 6
		rating = "\x83".."C".."\x80"
	elseif wt > 4
		rating = "\x81".."B".."\x80"
	elseif wt > 2
		rating = "\x85".."A".."\x80"
	else
		rating = "\x82".."S".."\x80"
	end

	return rating
end

local function GetBoostCost(skin)
	local wt = skins[skin].kartweight
	local spd = skins[skin].kartspeed
	
	local fuel_econ = ((26*4 + (spd - 1) + wt*2)*8)

	local rating
	
	if fuel_econ > 992 then
		rating = "\x83".."C".."\x80"
	elseif fuel_econ > 944
		rating = "\x81".."B".."\x80"
	elseif fuel_econ > 896
		rating = "\x85".."A".."\x80"
	else
		rating = "\x82".."S".."\x80"
	end

	return rating
end

local function GetBoostPower(skin)
	local accel = max(0, 9 - skins[skin].kartspeed)
	local weight = max(0, 9 - skins[skin].kartweight)
	local bonus_factor = FixedDiv((125-100)*FRACUNIT, 100*FRACUNIT)
	local base_boost = FRACUNIT/2
	local boost_strength = base_boost + FixedMul(FixedDiv(bonus_factor, 16*FRACUNIT), (accel*FRACUNIT + weight*FRACUNIT))
	local rating
	
	if boost_strength > 69*FRACUNIT/100 then
		rating = "\x82".."S".."\x80"
	elseif boost_strength > 63*FRACUNIT/100 then
		rating = "\x85".."A".."\x80"
	elseif boost_strength > 57*FRACUNIT/100 then
		rating = "\x81".."B".."\x80"
	else
		rating = "\x83".."C".."\x80"
	end

	return rating
end

local function GetDefense(skin)
	local wt = skins[skin].kartweight
	local spd = skins[skin].kartspeed
	
	local defense = ((26*4 + (spd - 1) + wt*2)*8)
	local rating
	
	if defense > 992
		rating = "\x82".."S".."\x80"
	elseif defense > 944
		rating = "\x85".."A".."\x80"
	elseif defense > 896
		rating = "\x81".."B".."\x80"
	else
		rating = "\x83".."C".."\x80"
	end

	return rating
end

local function GetHealing(skin)
	local spd = max(0, 9 - skins[skin].kartspeed)
	local wt = max(0, 9 - skins[skin].kartweight)
	local bonus_factor = FixedDiv(FRACUNIT, 2*FRACUNIT)
	local heal_scale = FixedMul(FixedDiv(bonus_factor, 16*FRACUNIT), (spd + wt)*FRACUNIT)
	local heal_bonus = FixedInt(FixedMul(100*FRACUNIT, heal_scale))
	local total_heal = 100 + heal_bonus
	local rating

	if total_heal > 137 then
		rating = "\x82".."S".."\x80"
	elseif total_heal > 125 then
		rating = "\x85".."A".."\x80"
	elseif total_heal > 112 then
		rating = "\x81".."B".."\x80"
	else
		rating = "\x83".."C".."\x80"
	end
	
	return rating
end

local function PrintStats(p, skin, num)
	local health_max = GetMaxHealth(skin)
	local tspd = GetTopSpeed(skin)
	local accel = GetAcceleration(skin)
	local handling = GetHandling(skin)
	local grip = GetGrip(skin)
	local boost_cost = GetBoostCost(skin)
	local boost_power = GetBoostPower(skin)
	local defense = GetDefense(skin)
	local healing = GetHealing(skin)

	CONS_Printf(p, "#"..string.format("%03i", num)..": "..colLookup[skins[skin].prefcolor]..skins[skin].realname)
	CONS_Printf(p, "--------------------------")
	CONS_Printf(p, "MAX EN | T.SPEED | ACCLRT")
	CONS_Printf(p, " "..health_max.."  | "..tspd.." |   "..accel)
	CONS_Printf(p, "--------------------------")
	CONS_Printf(p, "HNDLNG | TRCTION | B.COST")
	CONS_Printf(p, "  "..handling.."    |    "..grip.."    |   "..boost_cost)
	CONS_Printf(p, "--------------------------")
	CONS_Printf(p, "B.POWR | DEFENSE | HEALNG")
	CONS_Printf(p, "  "..boost_power.."    |    "..defense.."    |   "..healing)
	CONS_Printf(p, "--------------------------")
end

local skintable = {}

FZeroKart.CharList = function(p, arg)
	local guard = tonumber(arg) or 1
	local rangehelp = ""
	local pagesize = 10
	local adjust = 0
	local total = #skins
	if total % pagesize then
		adjust = 1
	end
	if guard < 0 or guard > (total / pagesize + adjust) then
		guard = 1
		rangehelp = "(ignored your page number, out of range)"
	end
	local pagedivider = "\=== Page " .. guard .. " of " .. (total/pagesize + adjust) .. " === " .. rangehelp
	guard = $ - 1
	local lowbound = guard * pagesize + 1
	local highbound = min(total, guard * pagesize + pagesize)
	CONS_Printf(p, pagedivider)
	for h = lowbound, highbound do
		local chara = skins[h-1]
		PrintStats(p, chara.name, h)
	end
	CONS_Printf(p, pagedivider)
end
COM_AddCommand("fzero_charlist", FZeroKart.CharList)

FZeroKart.GetSkinData = function(skin)
	local skin_num

	for i = 0, #skins-1
		if skins[skin].name == skins[i].name then
			skin_num = i + 1
			break
		end
	end
	
	return "#"..string.format("%03i", skin_num)..": "..colLookup[skins[skin].prefcolor]..skin.."\128/"..colLookup[skins[skin].prefcolor]..skins[skin].realname
end

FZeroKart.CharInfo = function(p, ...)
	-- Copying Hornmod because good reference is good
	local packedargs = {...}
	if #packedargs == 0 then
		CONS_Printf(p, "* \131(Trying \130fzero_charlist\131...)")
		FZeroKart.CharList(p, 1)
		return
	end

	local guard = nil
	if #packedargs == 1 then
		guard = tonumber(packedargs[1])
	end
	
	if guard == nil or #packedargs > 1 then -- no direct number match, let's try a fuzzy search
		local searchstring = table.concat(packedargs, " "):lower()
		local hits = {}
		for i = 0, #skins-1
			if string.find(skins[i].name:lower(), searchstring, 0, true)
			or string.find(skins[i].realname:lower(), searchstring, 0, true)then
				table.insert(hits, skins[i].name)
			end
		end
		if #hits > 1 then
			for k, v in ipairs(hits) do
				CONS_Printf(p, FZeroKart.GetSkinData(v))
			end
			CONS_Printf(p, "\133Multiple skins match \135" .. searchstring .. "\133. \128Could you be more specific?")
			return
		elseif #hits == 0 then
			CONS_Printf(p, "\133No skins match \135" .. searchstring .. "\133. \128Check your spelling?")
			return
		else
			guard = hits[1]
		end
	end

	if type(guard) == "number" then
		if guard < 0 or guard > #skins then
			CONS_Printf(p, "\133Out of range. \128Try a number between 1 and " .. #skins .. ", or use \135fzero_charlist\128.")
			return
		end
		
		guard = $-1
	end
	
	local skin_num
	for i = 0, #skins-1
		if skins[guard].name == skins[i].name then
			skin_num = i + 1
			break
		end
	end
	PrintStats(p, guard, skin_num)
	
end
COM_AddCommand("fzero_charinfo", FZeroKart.CharInfo)