local panel = {"MT_VL2ITEM_PANNEL", "S_VL2ITEM_PANNEL"}

for _,i in ipairs(panel)
	if not rawget(_G, i) then
		freeslot(i)
	end
end

local function tryUseItemPannel(mo, mot)
	if not (mot and mot.valid
	and mot.player and mot.player.valid
	and not mot.player.spectator) then
		return true
	end
	if mo.state ~= S_VL2ITEM_PANNEL then return true end
	
	if mot.player.fzerokart.heal_cooldown > 0 then
		return true
	end
	
	return true
end

local function itemPannelThink(mo)
	if not (mo.subsector and mo.subsector.valid
	and mo.subsector.sector and mo.subsector.sector.valid) then
		return
	end
	local sect = mo.subsector.sector
	if mo.state == S_VL2ITEM_PANNEL then
		for mo2 in sect.thinglist() do
			tryUseItemPannel(mo, mo2)
		end
	end
end

addHook("MobjThinker", itemPannelThink, MT_VL2ITEM_PANNEL)