-- Stole constants from paraglider lua haha
local PG_PLAYERMAXSTOREDFALL = 44*FRACUNIT
local PG_STORESPEEDTHRESHOLD = 4*PG_PLAYERMAXSTOREDFALL/5

addHook("MobjThinker", function(pmo)
	if not (pmo.player.fzerokart and pmo.player.fzerokart.super_booston) then 
		return
	end

    pmo.storedGlideMomz = PG_STORESPEEDTHRESHOLD
    if pmo.paragliding then
        local speed = FixedHypot(pmo.momx, pmo.momy)
        pmo.momx = FixedMul(cos(pmo.angle), speed)
        pmo.momy = FixedMul(sin(pmo.angle), speed)
    end
end, MT_PLAYER)
