FZeroKart.PlayerBump = function(mo1, mo2)
	if not FZeroKart.Active.value then return end
	if not (mo1 and mo1.valid and mo1.player) then return end
	if not (mo2 and mo2.valid and mo2.player) then return end

	local p1, p2 = mo1.player, mo2.player

    if p2 then
		//this hack here to make sneaker ramming not damage teammates in friendmod
		local teamattack = CV_FindVar("fr_teamattack")
		local psteamattack = CV_FindVar("ps_teamattack")
		if teamattack then
			if FRIENDMOD_TeamBattle() and FRIENDMOD_CheckTeams() and not teamattack.value then //I had to add a hook for this im scared
				if p1.FRteam == p2.FRteam then
					return
				end
			end
		end
		if psteamattack then
			if PALSCRIPT_TeamBattle() and PALSCRIPT_CheckTeams() and not psteamattack.value then
				if p1.PSteam and p1.PSteam>0 and p2.PSteam and p2.PSteam>0 and p1.PSteam == p2.PSteam then
					return
				end
			end
		end

        if not ((mo2.z <= mo1.z + mo1.height) and (mo2.z + mo2.height >= mo1.z)) then
            return
        end
		
		p1.fzerokart.bumper = p2
		p1.fzerokart.bumper_timer = TICRATE*5
		--print("Bumper Time!")
		p2.fzerokart.bumper = p1
		p2.fzerokart.bumper_timer = TICRATE*5

		if not p1.kartstuff[k_sneakertimer] and not p2.kartstuff[k_sneakertimer] then
			return
		end

		if p1.fzerokart.super_booston or p2.fzerokart.super_booston then return end

		if p1.kartstuff[k_sneakertimer] and p2.kartstuff[k_sneakertimer] or
		((leveltime < 236+TICRATE*3 and (p1.kartstuff[k_sneakertimer] or p2.kartstuff[k_sneakertimer]))) then 
		//reduced damage to both players
			local frontanglerange = ANG1*82
			local bh1 = abs(p1.mo.angle - R_PointToAngle2(p1.mo.x, p1.mo.y, p2.mo.x, p2.mo.y)) > frontanglerange
			local bh2 = abs(p2.mo.angle - R_PointToAngle2(p2.mo.x, p2.mo.y, p1.mo.x, p1.mo.y)) > frontanglerange
			
			if FZeroKart.ShouldHurt(p1) then
				if p1.fzerokart.spin_immune_timer <= 0 and p2.kartstuff[k_sneakertimer] then
					local spd = min(p1.kartspeed, 9)
					local wt = min(p1.kartweight, 9)
					local def = (26*4 + (spd-1) + wt*2)*8
					local base_dmg = FixedInt(FixedMul(p2.speed, 2*FRACUNIT))
					if not (bh1 or bh2) then
						base_dmg = FixedInt(FixedMul(p2.speed + p1.speed, 2*FRACUNIT))
					end
					local bonus_dmg = FixedDiv(2*base_dmg*FRACUNIT, 5*FRACUNIT)
					local total_dmg = base_dmg + FixedInt(FixedMul(FixedDiv(bonus_dmg, 192*FRACUNIT), (1040-def)*FRACUNIT))
					FZeroKart.DamagePlayer(p1, total_dmg/2, p2, false, true) //nonfatal
					p1.fzerokart.spin_immune_timer = 8 //evil
				end
			end
			
			if FZeroKart.ShouldHurt(p2) then
				if p2.fzerokart.spin_immune_timer <= 0 and p1.kartstuff[k_sneakertimer] then
					local spd = min(p2.kartspeed, 9)
					local wt = min(p2.kartweight, 9)
					local def = (26*4 + (spd-1) + wt*2)*8
					local base_dmg = FixedInt(FixedMul(p1.speed, 2*FRACUNIT))
					if not (bh1 or bh2) then
						base_dmg = FixedInt(FixedMul(p1.speed + p2.speed, 2*FRACUNIT))
					end
					local bonus_dmg = FixedDiv(2*base_dmg*FRACUNIT, 5*FRACUNIT)
					local total_dmg = base_dmg + FixedInt(FixedMul(FixedDiv(bonus_dmg, 192*FRACUNIT), (1040 - def)*FRACUNIT))

					FZeroKart.DamagePlayer(p2, total_dmg/2, p1, false, true) //nonfatal
					p2.fzerokart.spin_immune_timer = 8
				end
			end
		elseif (p1.kartstuff[k_sneakertimer] and not p2.kartstuff[k_sneakertimer]
		or p2.kartstuff[k_sneakertimer] and not p1.kartstuff[k_sneakertimer]) then
			local attacker, victim, sneakdamage
			--detect who wins fight
			if p1.kartstuff[k_sneakertimer] > p2.kartstuff[k_sneakertimer] then
				attacker = mo1
				victim = p2
			else
				attacker = mo2
				victim = p1
			end

			if victim.fzerokart.spin_immune_timer > 0 then
				return
			end

			local frontanglerange = ANG1*82
			local spd = min(victim.kartspeed, 9)
			local wt = min(victim.kartweight, 9)
			local def = (26*4 + (spd-1) + wt*2)*8
			local bh1 = abs(attacker.angle - R_PointToAngle2(attacker.x, attacker.y, victim.mo.x, victim.mo.y)) > frontanglerange
			local bh2 = abs(victim.mo.angle - R_PointToAngle2(victim.mo.x, victim.mo.y, attacker.x, attacker.y)) > frontanglerange
			local base_dmg = FixedInt(FixedMul(max(attacker.player.speed - victim.speed, 0), 2*FRACUNIT))
			if not (bh1 or bh2) then
				base_dmg = FixedInt(FixedMul(attacker.player.speed + victim.speed, 2*FRACUNIT))
			end
			local bonus_dmg = FixedDiv(2*base_dmg*FRACUNIT, 5*FRACUNIT)
			local sneakdamage = base_dmg + FixedInt(FixedMul(FixedDiv(bonus_dmg, 192*FRACUNIT), (1040 - def)*FRACUNIT))
			
			if FZeroKart.ShouldHurt(victim) then -- 
				FZeroKart.DamagePlayer(victim, sneakdamage, attacker.player, false, victim.fzerokart.energy > 1 and true or false)
			end
			
			victim.fzerokart.spin_immune_timer = 25
			--print("bonk")
			K_PlayHitEmSound(attacker) //lol
			if hitfeed then
				HF_SendHitMessage(FZeroKart.HitfeedInfo(attacker.player), FZeroKart.HitfeedInfo(victim), "K_HMSHOE")
			end
		end
    end
end

addHook("MobjCollide", FZeroKart.PlayerBump, MT_PLAYER)
addHook("MobjMoveCollide", function(mo2, mo1)
    if mo1.player then return FZeroKart.PlayerBump(mo1, mo2) end
end, MT_PLAYER)

FZeroKart.PlayerDeath = function(pmo, mo, pmo2)
	if not FZeroKart.Active.value then return end
	 
	if not (pmo and pmo.valid and pmo.player and pmo.player.valid) then return end
	if pmo.player.pflags & PF_TIMEOVER then return end

	if pmo.player.spectator then return end

	local attacker = nil
	if pmo2 and pmo2.valid and pmo2.player then
		attacker = pmo2.player
	end
	
	if mo and mo.valid and mo.type == MT_SINK then
		FZeroKart.DamagePlayer(pmo.player, 1000, attacker, true)
		local boom = P_SpawnMobj(pmo.x, pmo.y, pmo.z, MT_FZEROBOOM)
		boom.scale = pmo.scale
		boom.angle = pmo.angle
		boom.target = pmo
		boom.fuse = 3*TICRATE
		return
	end

	if pmo.player and pmo.player.fzerokart.bumper and pmo.player.fzerokart.bumper.valid then
		attacker = pmo.player.fzerokart.bumper
	else
		attacker = nil
	end
	
	if pmo.player.fzerokart.super_booston then
		pmo.player.fzerokart.super_booston = nil
		pmo.player.fzerokart.super_boost = 0
		
		if hitfeed then
			if not HF_animIcon["K_HMFAL"] then
				//print("no fall icon registered registering")
				HF_animIcon["K_HMFAL"] = {4, 6}
				//print("registered fall icon")
			end
			HF_SendHitMessage(FZeroKart.HitfeedInfo(attacker), FZeroKart.HitfeedInfo(pmo.player), "K_HMFAL")
		end
		S_StartSound(pmo, sfx_fzfall, pmo.player)
		return -- No need to punish them any further for trying to catch up
	end
	
	if pmo.player.fzerokart.forcelanding then
		if hitfeed then
			if not HF_animIcon["K_HMFAL"] then
				//print("no fall icon registered registering")
				HF_animIcon["K_HMFAL"] = {4, 6}
				//print("registered fall icon")
			end
			HF_SendHitMessage(FZeroKart.HitfeedInfo(attacker), FZeroKart.HitfeedInfo(pmo.player), "K_HMFAL")
		end
		S_StartSound(pmo, sfx_fzfall, pmo.player)
		return
	end

	if FZeroKart.InstaDeath.value then
		FZeroKart.DamagePlayer(pmo.player, 1000, attacker, true)
	else
		if pmo.player.fzerokart.energy - 300 > 0 then
			S_StartSound(pmo, sfx_fzfall, pmo.player)
		end
		FZeroKart.DamagePlayer(pmo.player, 300, attacker)
	end
	--print("Attacker: "..attacker and attacker.name or nil)

	if hitfeed then
		if not HF_animIcon["K_HMFAL"] then
			//print("no fall icon registered registering")
			HF_animIcon["K_HMFAL"] = {4, 6}
			//print("registered fall icon")
		end
		HF_SendHitMessage(FZeroKart.HitfeedInfo(attacker), FZeroKart.HitfeedInfo(pmo.player), "K_HMFAL")
	end
end
addHook("MobjDeath", FZeroKart.PlayerDeath, MT_PLAYER)

FZeroKart.PlayerSquish = function(p, mo, pmo)
	if not FZeroKart.Active.value then return end
	 
	if not (p and p.valid) then return end
	local plr = (pmo and pmo.valid) and pmo.player or nil
	FZeroKart.DamagePlayer(p, 1000, plr, true)
	
	return
end
addHook("PlayerSquish", FZeroKart.PlayerSquish)

FZeroKart.ShouldHit = function(p, inf, source)
	if not FZeroKart.Active.value then return end
	 
	if not (p and p.valid) then return end
	if not p.fzerokart then return end
	if not FZeroKart.ShouldHurt(p) then return false end
	
	-- Lose a boost's worth of health
	local dmg = FixedInt(FixedDiv(11*K_GetKartDriftSparkValue(p)*FRACUNIT, 40*FRACUNIT))
	
	FZeroKart.DamagePlayer(p, dmg, source, false, p.fzerokart.energy > 1 and true or false)
	p.powers[pw_flashing] = TICRATE

	return false
end
addHook("ShouldSpin", FZeroKart.ShouldHit)
addHook("ShouldExplode", FZeroKart.ShouldHit)

FZeroKart.ShouldDamage = function(mo, inf, source, damage)
	if not FZeroKart.Active.value then return end
	 
	if not (mo and mo.valid and mo.player) then return end
	local p = mo.player
	
	if damage < 10000 then
		if not p.fzerokart then return end
		if not FZeroKart.ShouldHurt(p) then return end

		local dmg = 100 + (5*(11-p.kartweight))
		
		FZeroKart.DamagePlayer(p, dmg, source, false, p.fzerokart.energy > 1 and true or false)
		p.powers[pw_flashing] = TICRATE

		return false
	end
	
	return
end

addHook("ShouldDamage", FZeroKart.ShouldDamage)

FZeroKart.PlayerSpawn = function(p)
	if not p.fzerokart then
		FZeroKart.PlayerInit(p)
	end
end
--addHook("PlayerSpawn", FZeroKart.PlayerSpawn)

FZeroKart.HealCooldown = function(mo, mo2)
	if not FZeroKart.Active.value then return end
	if not (mo2 and mo2.valid and mo2.player) then return end
	
	local p = mo2.player

	if p.fzerokart.heal_cooldown > 0
		return true
	end

	return
end
addHook("TouchSpecial", FZeroKart.HealCooldown, MT_RANDOMITEM)

FZeroKart.HealBox = function(mo)
	if not (mo and mo.valid) then return end
	if not FZeroKart.Active.value then return end
	
	mo.colorized = true
	mo.color = SKINCOLOR_LIME
end
addHook("MobjThinker", FZeroKart.HealBox, MT_RANDOMITEM)