-- Original Spin Move made by NepDisk + Indev + Onyo
-- Refactored and Gutted By Dinomial + Retrostation

--performance shit
local k_eggmanexplode = k_eggmanexplode
local k_growshrinktimer = k_growshrinktimer
local k_invincibilitytimer = k_invincibilitytimer
local k_spinouttimer = k_spinouttimer
local k_itemtype = k_itemtype
local k_itemroulette = k_itemroulette
local k_itemheld = k_itemheld
local k_eggmanheld = k_eggmanheld
local k_rocketsneakertimer = k_rocketsneakertimer
local k_stolentimer = k_stolentimer
local k_stealingtimer = k_stealingtimer
local k_growshrinktimer = k_growshrinktimer
local FRACUNIT = FRACUNIT

-- Values
local max_timer = 22
local use_cooldown = 105
local race_start_cooldown = 490

local function setplayerspinvars(p)
	p.nspintimer = 0
	p.nspinready = 1
	p.nspincooldown = use_cooldown
	p.nspinplyrlck = 0
	p.nspinnotify = 0
	p.nspinicontimer = 0
end 

local function canplayerrecharge(p)
    return (not P_IsObjectOnGround(p.mo) and (not p.kartstuff[k_respawn]) and p.kartstuff[k_spinouttimer] == 0 and p.playerstate ~= PST_DEAD and leveltime >= 236 and (not p.fzerokart.spinrefresh) and (not p.mo.paragliding))
end 

local function spinmove(p)
	if(not p.kartstuff[k_invincibilitytimer]) then
		if p.nspintimer then
			K_SpawnSparkleTrail(p.mo)
		end
	end
	
		
	--Thok Trail
	local thok = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
	thok.color = p.skincolor
	thok.scale = p.mo.scale*3/5
		
	--Spin timers
	p.nspintimer = max($ - 1, 0)
		
	--Give FlashTics and animate spin
	p.frameangle = $1 + ANGLE_22h * p.spinanim -- The actual *spinning*.
	
end


--thanks indev
local function onCollide(pmo, pmo2)
	if not FZeroKart.Active.value then return end
	 
    if not pmo2.player then return end -- Don't care about non-players
    
    -- ffs srb2 why do i have to do this - Indev
    if pmo.z > pmo2.z+pmo2.height or pmo.z+pmo.height < pmo2.z then return end

	-- Setup player variables
    local player = pmo.player
    local otherplayer = pmo2.player

	local attacker, victim
	
	-- Check who wins the interaction
	if player.nspintimer and FZeroKart.ShouldHurt(otherplayer)
		attacker = player
		victim = otherplayer
	elseif otherplayer.nspintimer and FZeroKart.ShouldHurt(player)
		attacker = otherplayer
		victim = player
	end

    if (attacker and attacker.valid) and (victim and victim.valid) then
		--Spin Lock check. 
		--To prevent certain actions from repeating when inside someone
		if attacker.nspinplyrlck == 0 then
			if (hitfeed)
				local s = {{attacker.name, attacker.mo.hf_overridenamecolor or attacker.skincolor}, {skins[attacker.mo.skin].facemmap, attacker.skincolor}, attacker}
				local v = {{victim.name, victim.mo.hf_overridenamecolor or victim.skincolor}, {skins[victim.mo.skin].facemmap, victim.skincolor}, victim}
				local icon = "K_HMSPIN"
				if not attacker.kartstuff[k_sneakertimer] then
					HF_SendHitMessage(s, v, icon)
				end
			end
			
			-- Sneaker Ram takes priority
			local frontanglerange = ANG1*82
			local spd = min(victim.kartspeed, 9)
			local wt = min(victim.kartweight, 9)
			local def = ((26*4 + (spd - 1) + wt*2)*8)

			local behind1 = abs(attacker.mo.angle - R_PointToAngle2(attacker.mo.x, attacker.mo.y, victim.mo.x, victim.mo.y)) > frontanglerange
			local behind2 = abs(victim.mo.angle - R_PointToAngle2(victim.mo.x, victim.mo.y, attacker.mo.x, attacker.mo.y)) > frontanglerange
			local base_dmg = FixedInt(FixedMul(max(attacker.speed - victim.speed, 25*FRACUNIT), FRACUNIT*2))

			if not behind1
			and not behind2 then
				--print("Players are facing each other")
				base_dmg = FixedInt(FixedMul(max(attacker.speed + player.speed, 25*FRACUNIT), FRACUNIT*2))
			end

			local bonus_dmg = FixedDiv(2*base_dmg*FRACUNIT, 5*FRACUNIT)
			local total_dmg = base_dmg + FixedInt(FixedMul(FixedDiv(bonus_dmg, 192*FRACUNIT), (1040-def)*FRACUNIT))

			if not attacker.kartstuff[k_sneakertimer] then
				FZeroKart.DamagePlayer(victim, total_dmg, attacker, false, victim.fzerokart.energy > 1 and true or false)
				victim.fzerokart.spin_immune_timer = 25
			end
			--Cue Spring Yard Bumper sound
			S_StartSound(victim.mo, sfx_s1b4)
			
			--Push Victim player 
			--P_Thrust(player.mo,otherplayer.mo.angle,mapobjectscale*10)
			
			attacker.nspinplyrlck = 1
		end
		
		-- Funni Bump Check
		local wref, wref2 = attacker.kartweight, victim.kartweight
		attacker.kartweight = $*2
		victim.kartweight = 0
		K_KartBouncing(attacker.mo, victim.mo, true, false)
		attacker.kartweight = wref
		victim.kartweight = wref2
	elseif FZeroKart.ShouldHurt(player) and FZeroKart.ShouldHurt(otherplayer)
	and not (player.kartstuff[k_sneakertimer] or otherplayer.kartstuff[k_sneakertimer]) then
		local frontanglerange = ANG1*82
		
		local spd1 = min(player.kartspeed, 9)
		local wt1 = min(player.kartweight, 9)
		local def1 = ((26*4 + (spd1 - 1) + wt1*2)*8)

		local spd2 = min(otherplayer.kartspeed, 9)
		local wt2 = min(otherplayer.kartweight, 9)
		local def2 = ((26*4 + (spd2 - 1) + wt2*2)*8)

		local behind1 = abs(otherplayer.mo.angle - R_PointToAngle2(otherplayer.mo.x, otherplayer.mo.y, player.mo.x, player.mo.y)) > frontanglerange
		local behind2 = abs(player.mo.angle - R_PointToAngle2(player.mo.x, player.mo.y, otherplayer.mo.x, otherplayer.mo.y)) > frontanglerange

		if not player.fzerokart.spin_immune_timer then
			local base_dmg = FixedInt(FixedMul(max(otherplayer.speed - player.speed, 0), FRACUNIT*2))
			
			if not behind1
			and not behind2 then
				--print("Players are facing each other")
				base_dmg = FixedInt(FixedMul(otherplayer.speed + player.speed, FRACUNIT*2))
			end

			local bonus_dmg = FixedDiv(2*base_dmg*FRACUNIT, 5*FRACUNIT)
			local total_dmg = base_dmg + FixedInt(FixedMul(FixedDiv(bonus_dmg, 192*FRACUNIT), (1040-def1)*FRACUNIT))
			
			
			FZeroKart.DamagePlayer(player, total_dmg, otherplayer, false, player.fzerokart.energy > 1 and true or false)
			FZeroKart.DamagePlayer(otherplayer, total_dmg/2, otherplayer, false, player.fzerokart.energy > 1 and true or false)
			player.fzerokart.spin_immune_timer = TICRATE/2
		end

		if not otherplayer.fzerokart.spin_immune_timer then
			local base_dmg = FixedInt(FixedMul(max(player.speed - otherplayer.speed, 0), FRACUNIT*2))
			if not behind1
			and not behind2 then
				--print("Players are facing each other")
				base_dmg = FixedInt(FixedMul(player.speed + otherplayer.speed, FRACUNIT*2))
			end

			local bonus_dmg = FixedDiv(2*base_dmg*FRACUNIT, 5*FRACUNIT)
			local total_dmg = base_dmg + FixedInt(FixedMul(FixedDiv(bonus_dmg, 192*FRACUNIT), (1040 - def2)*FRACUNIT))
			
			FZeroKart.DamagePlayer(otherplayer, total_dmg, player, false, otherplayer.fzerokart.energy > 1 and true or false)
			FZeroKart.DamagePlayer(player, total_dmg/2, player, false, player.fzerokart.energy > 1 and true or false)
			otherplayer.fzerokart.spin_immune_timer = TICRATE/2
		end
    end
end

local function cancelSpin(player)
    if not (player.mo and player.mo.valid) then return end
	if not FZeroKart.Active.value then return end
	 
	player.nspintimer = 0
	
end

--Reload reload playervars at the start of everyrace
addHook("MapLoad", do
    for p in players.iterate do 
		p.nspinready = nil
		if p.mo and not p.spectator
			setplayerspinvars(p)
		end
    end 
end)

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid) then return end
	if not p.fzerokart then return end
	local p_spinning = (p.mo.state == S_KART_SPIN or p.mo.state == S_KART_PAIN)
	
	/*
	if not P_IsObjectOnGround(p.mo) then
		P_SetObjectMomZ(p.mo, gravity/2, true)
	end
	*/

	--Setup spin if player joins mid-game
	if not p.nspinready then
		setplayerspinvars(p) 
	end
	
	if not FZeroKart.Active.value then return end
	 
	--I hope you like timers :)
	if leveltime >= 236 then
		p.nspincooldown = max($ - 1, 0)
	end
	p.nspinicontimer = max($ - 1, 0)
	
	if not p.nspintimer then
		 p.nspinplyrlck = 0
		 p.spinanim = 10
	end
		
	if (p.nspintimer > 0) then 
		spinmove(p)
		p.spinanim = $ + 1
    elseif (p.kartstuff[k_pogospring] == 0 and not p_spinning) then 
		p.frameangle = p.mo.angle
    end
	
	if canplayerrecharge(p) then
		if p.fzerokart.lastz ~= nil
		and (p.mo.z > (p.fzerokart.lastz + 1)) or (p.mo.z < (p.fzerokart.lastz - 1) and p.mo.eflags & MFE_VERTICALFLIP) then
			if p.nspincooldown then
				p.nspincooldown = 0
			end
			
			p.fzerokart.spinrefresh = true
		end
	end	

	if (P_IsObjectOnGround(p.mo)
	and p.fzerokart.spinrefresh) then
		p.fzerokart.spinrefresh = nil
	end

	if (p.nspincooldown == 0) and not p.nspinnotify then
		S_StartSound(nil, sfx_cdfm68, p)
		p.nspinicontimer = 14
		p.nspinnotify = 1
	end
		
		
	--Spin input detection
	if (p.cmd.buttons & BT_ATTACK) then 
		if p.playerstate == PST_LIVE
		and not p.nspincooldown 
		and not p.spinlfroulette and not p.spinlfitem
		and not p.spinlfheld and not p.spinlfeggman
		and not p.spinlfsneaker and not p.kartstuff[k_eggmanexplode] 
		and not p.spinlfstolen and not p.spinlfstealing
		and not p.spinlfgrow and not p.kartstuff[k_respawn]
		and not p.kartstuff[k_spinouttimer]
		and leveltime >= 236 then
			S_StartSound(p.mo, sfx_s3k40)
			p.nspintimer = max_timer
			p.nspincooldown = use_cooldown
			p.nspinnotify = 0
			
			if p.cmd.driftturn then
				local angmod = 90*ANG1
				
				if p.cmd.driftturn < 0 then -- Right turn
					angmod = -90*ANG1
				end
					
				P_Thrust(p.mo, p.mo.angle + angmod, p.mo.radius*2)
			end
		end
	end
	
	--Update timers at end of frame
	p.spinlfitem = p.kartstuff[k_itemtype]
    p.spinlfroulette = p.kartstuff[k_itemroulette]
	p.spinlfheld = p.kartstuff[k_itemheld]
	p.spinlfeggman = p.kartstuff[k_eggmanheld]
	p.spinlfsneaker = p.kartstuff[k_rocketsneakertimer]
	p.spinlfgrow = HugeQuest and p.hugequest.huge or p.kartstuff[k_growshrinktimer]
	p.spinlfstolen = p.kartstuff[k_stolentimer]
	p.spinlfstealing = p.kartstuff[k_stealingtimer]
	p.fzerokart.lastz = p.mo.z
end)

--Cancel Spin if spunout
addHook("PlayerSpin", cancelSpin)	
addHook("PlayerExplode", cancelSpin)
addHook("PlayerSquish", cancelSpin)

--Player Collide
addHook("MobjCollide", onCollide, MT_PLAYER)
addHook("MobjMoveCollide", function(pmo2, pmo)
    if pmo.player then return onCollide(pmo, pmo2) end
end, MT_PLAYER)